import array, sys

def intlist_to_string(v): return ' '.join(map(str, v))

def invrange(*v):
    r = range(*v);
    r.reverse()
    return r

class set:
    def __init__(self): self.d = {}
    def insert(self, elem): self.d[elem] = 1
    def remove(self, elem):
        try: del self.d[elem]
        except KeyError: pass # element wasn't there
    def __contains__(self, elem): return elem in self.d
    def __iter__(self): return self.d.iterkeys()
    def __str__(self): return '{' + ', '.join(map(str, self.d.keys())) + '}'

class array2:
    def __init__(self, X, Y, val):
        self.X = X
        self.Y = Y
        self.arr = val
    def __getitem__(self, p):
        x,y = p
        return self.arr[y*self.X + x]
    def __setitem__(self, p, val):
        x,y = p
        self.arr[y*self.X + x] = val
    def __repr__(self):
        return "<%dx%d '%s' array>" % (self.X, self.Y, self.arr.typecode)
    def printable(self): return self.X*self.Y <=1000
    def pos_to_index(self, pos):
        x,y = pos
        return y*self.X + x
    def index_to_pos(self, index):
        return index%self.X, index/self.X

class int_array2(array2):
    def __init__(self, X, Y, val):
        array2.__init__(self, X, Y, val=val)
    def getrow(self, y):
        index = y*self.X
        return `list(self.arr[index:index+self.X])`
    def __repr__(self):
        """Note: Prints with 0th row at bottom"""
        if not self.printable(): return array2.__repr__(self)
        else: return '[ ' + '\n  '.join([self.getrow(i) for i in range(self.Y-1, -1, -1)]) + ' ]'
    def copy(self):
        arr = array.array(self.arr.typecode, self.arr.tostring())
        return int_array2(self.X, self.Y, arr)

